<?php

namespace Drupal\nft_mint\Event;

use Drupal\nft\Utility\Transaction;
use Symfony\Component\EventDispatcher\Event;

/**
 * Defines the mint event.
 *
 * @see \Drupal\nft\Event\NftEvents
 */
class MintEvent extends Event {

  /**
   * The transaction received after the mint.
   *
   * @var \Drupal\nft\Utility\Transaction
   */
  protected $transaction;

  /**
   * Constructs a new object.
   *
   * @param \Drupal\nft\Utility\Transaction $transaction
   *   The transaction object.
   */
  public function __construct(Transaction $transaction) {
    $this->transaction = $transaction;
  }

  /**
   * Gets the transaction.
   *
   * @return \Drupal\nft\Utility\Transaction
   *   The transaction.
   */
  public function getTransaction() {
    return $this->transaction;
  }

}
