<?php

namespace Drupal\nft_mint\Minter\Annotation;

use Drupal\Component\Annotation\Plugin;

/**
 * Defines a minter annotation object.
 *
 * Plugin Namespace: Plugin\Minter
 *
 * @see plugin_api
 *
 * @Annotation
 */
class Minter extends Plugin {

  /**
   * The archiver plugin ID.
   *
   * @var string
   */
  public $id;

  /**
   * The human-readable name of the archiver plugin.
   *
   * @ingroup plugin_translatable
   *
   * @var \Drupal\Core\Annotation\Translation
   */
  public $title;

  /**
   * The description of the archiver plugin.
   *
   * @ingroup plugin_translatable
   *
   * @var \Drupal\Core\Annotation\Translation
   */
  public $description;

  /**
   * List of custom plugin forms.
   *
   * @see \Drupal\Core\Plugin\PluginWithFormTrait;
   *
   * @var array
   */
  public $forms;

  /**
   * The default IPFS provider.
   *
   * Only useful with `ipfs` module installed.
   *
   * @see \Drupal\nft_mint\Plugin\Minter\MinterBase::metadata();
   *
   * @var string
   */
  public $ipfs_provider;

}
