<?php

namespace Drupal\nft_mint_example\PluginForm;

use Drupal\Core\Form\FormStateInterface;
use Drupal\nft_mint\PluginForm\MinterBaseForm;

/**
 * Form class for the `minter_example_with_custom_config` plugin.

 * Provide a UX to configure the minter before "mint" operation.
 */
class MinterExampleWithCustomConfigForm extends MinterBaseForm {

  /**
   * {@inheritDoc}
   */
  public function customConfiguration() {
    return [
      'custom_field' => '',
    ];
  }

  /**
   * {@inheritDoc}
   */
  public function buildConfigurationForm(array $form, FormStateInterface $form_state) {
    $form = parent::buildConfigurationForm($form, $form_state);

    $form['custom_field']['#type'] = 'link';
    $form['custom_field']['#title'] = $this->t('Custom thing');

    return $form;
  }

}
