<?php

namespace Drupal\nft\Entity;

use Drupal\Component\Serialization\Json;
use Drupal\Core\Entity\EntityStorageInterface;
use Drupal\nft\Entity\NftInterface;
use Drupal\nft\Utility\Metadata;
use Drupal\node\Entity\Node;

class Nft extends Node implements NftInterface {

  /**
   * {@inheritdoc}
   */
  public function preSave(EntityStorageInterface $storage) {
    parent::preSave($storage);

    // @todo Populate title from metadata name key.
    $metadata = Json::decode($this->get('metadata')->getString());
    $this->set('title', $metadata['name'] ?? $this->get('uuid')->getString());
  }

  /**
   * {@inheritDoc}
   */
  public function getData(): Metadata {
    return new Metadata($this->get('metadata')->value);
  }

  /**
   * {@inheritDoc}
   */
  public function setData(Metadata $data) {
    $this->set('metadata', Json::encode($data->getValues()));
    return $this;
  }

}
