<?php

namespace Drupal\nft\Entity;

use Drupal\nft\Utility\Metadata;

/**
 * Defines getter and setter methods for NFT entitties.
 *
 * @ingroup nft
 */
interface NftInterface {

  /**
   * Indicates that the NFT has been minted on-chain.
   *
   * Not-yet-minted NFT lives in Drupal only - do not exist on any blockchain.
   */
  const MINTED = 1;

  /**
   * Gets the NFT info.
   *
   * @return \Drupal\nft\Utility\Metadata
   *   The metadata.
   */
  public function getData(): Metadata;

  /**
   * Set the NFT info.
   *
   * @param \Drupal\nft\Utility\Metadata $data
   *   The metadata.
   *
   * @return $this
   */
  public function setData(Metadata $data);

}
